#include <iostream>


using namespace std;


int a[50004];
int b[50004];
int c[50004];
int d[50004];
int nz[50004];



int main()
{
    int n, m;
    cin>>n>>m;
    long long sumad=0;
    for(int i=0; i<n; i++)
    {
        cin>>a[i]>>b[i];
    }
    for(int i=0; i<m; i++)
    {
        cin>>c[i]>>d[i];
        sumad+=d[i];
    }
    if(n==1)
    {
        if(sumad<=b[0])
        {
            for(int i=0; i<m; i++)
            {
                cout<<d[i]<<" ";
            }
        }
        else
        {
            long long sumat=sumad-b[0];
            long long suma=0;
            for(int i=0; i<m; i++)
            {
                if(suma+d[i]-c[i]>sumat)
                {
                    nz[i]=d[i]-(sumat-suma);
                    suma=sumat;
                }
                else
                {
                    nz[i]=c[i];
                    suma+=d[i]-c[i];
                }
            }
            for(int i=0; i<m; i++)
            {
                cout<<nz[i]<<" ";
            }
        }

    }
}